package ms.warpzone.warppay.dialogs;

import android.app.Dialog;
import android.graphics.Color;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.InputType;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import org.mindrot.jbcrypt.BCrypt;

import ms.warpzone.warppay.R;
import ms.warpzone.warppay.data.models.local.User;
import ms.warpzone.warppay.manager.DataManager;
import ms.warpzone.warppay.manager.MainManager;

public class PinCodesDialog extends Dialog implements View.OnClickListener, View.OnKeyListener {

    private User user;
    private Button btnSubmit;
    private EditText etxtPinCode;

    public PinCodesDialog(User user) {

        super(MainManager.getInstance().getMainActivity());
        this.user = user;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.pin_code_dialog);

        this.btnSubmit = (Button) findViewById(R.id.btnSumit);
        this.btnSubmit.setOnClickListener(this);

        this.etxtPinCode = (EditText) findViewById(R.id.etxtPinCode);
        this.etxtPinCode.setInputType(InputType.TYPE_CLASS_NUMBER | InputType.TYPE_NUMBER_VARIATION_PASSWORD);
        this.etxtPinCode.setOnKeyListener(this);
    }

    private void checkPin() {
        try {
            String pin = this.etxtPinCode.getText().toString();
            if (BCrypt.checkpw(pin, this.user.getPinCode())) {
                MainManager.getInstance().setCurrentUser(this.user, true);
                this.etxtPinCode.setEnabled(false);
                dismiss();
            } else {
                etxtPinCode.setBackgroundColor(Color.RED);
            }
        } catch(Exception e) {

        }
    }
    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btnSumit:
                this.checkPin();
                break;
             default:
                break;
        }

        dismiss();
    }

    @Override
    public boolean onKey(View view, int i, KeyEvent keyEvent) {
        if (KeyEvent.KEYCODE_ENTER == keyEvent.getKeyCode()) {
            this.checkPin();
        }
        return false;
    }
}
